﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class GameController : MonoBehaviour
{
    private GameObject[] buildingparts;
    private List<SquareManager> bombs = new List<SquareManager>();
    private LevelTimer timer;
    private Text score;
    // Start is called before the first frame update
    void Start()
    {
        buildingparts = GameObject.FindGameObjectsWithTag("BuildingPart");
        var bombparents = GameObject.FindGameObjectsWithTag("Bomb");
        foreach (GameObject bombparent in bombparents)
        {
            bombs.Add(bombparent.transform.Find("Square").GetComponent<SquareManager>());
        }
        timer = GameObject.Find("TimerHolder").GetComponent<LevelTimer>();
        score = GameObject.Find("Score").GetComponent<Text>();
    }

    // Update is called once per frame
    void Update()
    {
        if (timer.waitingForBomb())
        {
            foreach (SquareManager bomb in bombs)
            {
                bomb.state = SquareManager.eOBJ_STATE.SCALE_UP;
            }
        }
        if (timer.stabilityCheck())
        {
            foreach (GameObject part in buildingparts) {
                part.GetComponent<Rigidbody2D>().simulated = true;
            }
        }
        if(timer.levelComplete())
        {
            var total = 0.0f;
            foreach (GameObject part in buildingparts)
            {
                total += 90-Math.Abs(part.GetComponent<Rigidbody2D>().rotation);
            }
            

            score.text = ((int)total).ToString() + "★/" + (buildingparts.Length * 90).ToString() + "★" ;
        }
        if(timer.returnLevelSelect())
        {
            FadeManager.Instance.LoadScene("SelectScene", 0.5f);
        }
    }
}
