﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LevelTimer : MonoBehaviour
{
    public float secondsToBreak = 10.0f;
    public float secondsToBuild = 15.0f;
    public float secondsToCheckStability = 1.5f;
    public float secondsToComplete = 5.0f;
    public float alertTime = 10f;
    public float timer = 0.0f;
    // Start is called before the first frame update
    void Start()
    {
        
    }

    public bool alertStart()
    {
        var endTime = secondsToBreak + secondsToBuild;
        if (timer > endTime - alertTime && timer < endTime)
        {
            return true;
        }
        return false;
    }

    // Update is called once per frame
    void Update()
    {
        timer += Time.deltaTime;
    }

    public bool waitingForBomb()
    {
        if (timer < secondsToBreak) 
        {
            return true;
        }
        return false;
    }

    public bool buildOK()
    {
        if (timer> secondsToBreak && timer <secondsToBreak+secondsToBuild)
        {
            return true;
        }
        return false;
    }

    public bool stabilityCheck()
    {
        if (timer > secondsToBreak + secondsToBuild && timer < secondsToBreak + secondsToBuild + secondsToCheckStability)
        {
            return true;
        }
        return false;
    }

    public bool levelComplete()
    {
        if (timer > secondsToBreak + secondsToBuild + secondsToCheckStability && timer < secondsToBreak + secondsToBuild + secondsToCheckStability + secondsToComplete)
        {
            return true;
        }
        return false;
    }

    public bool returnLevelSelect()
    {
        if (timer > secondsToBreak + secondsToBuild + secondsToCheckStability + secondsToComplete)
        {
            return true;
        }
        return false;
    }
}
