﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MoveBlockController: MonoBehaviour
{
    LevelTimer script;
    bool rotated = false;

    //物体の角度変化
    private float rotationAngle = 0.0f;
    // Start is called before the first frame update
    void Start()
    {
        script = GameObject.Find("TimerHolder").GetComponent<LevelTimer>();
    }

    // Update is called once per frame
    void Update()
    {
        //過度に足さない
        if(rotationAngle >= 360.0f)
        {
            rotationAngle = 0;
        }

        if(script.stabilityCheck())
        {
            gameObject.GetComponent<Rigidbody2D>().gravityScale = 1;
        }

    }

    private Vector3 screenPoint;
    private Vector3 offset;

    void OnMouseOver()
    {
        if (Input.GetMouseButtonDown(1) && !rotated)
        {
            rotationAngle += 90.0f;
            gameObject.transform.rotation = Quaternion.Euler(0, 0, rotationAngle);
            rotated = true;
        }
        else
        {
            rotated = false;
        }
      
    }

    void OnMouseDown()
    {
        // このオブジェクトの位置(transform.position)をスクリーン座標に変換。
        screenPoint = Camera.main.WorldToScreenPoint(transform.position);
        // ワールド座標上の、マウスカーソルと、対象の位置の差分。
        offset = transform.position - Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, screenPoint.z));
    }

    void OnMouseDrag()
    {
        if (script.buildOK())
        {
            Vector3 currentScreenPoint = new Vector3(Input.mousePosition.x, Input.mousePosition.y, screenPoint.z);
            Vector3 currentPosition = Camera.main.ScreenToWorldPoint(currentScreenPoint) + this.offset;
            transform.position = currentPosition;
        }
    }
}
