﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SquareManager : MonoBehaviour
{
    Vector3 squarePos;
    Vector3 size;

    //bool bombFlag = false;
    SpriteRenderer s;

    float changeColorTimer = 0f;

    private LevelTimer timer;

    public enum eOBJ_STATE
    {
        PREPARING,  // 準備
        SCALE_UP,   // 拡大
        BOMB,       // 爆発
    }

    enum eOBJ_COLOR_STATE
    {
        WHITE,
        RED,
    }

    public eOBJ_STATE state = eOBJ_STATE.PREPARING;

    eOBJ_COLOR_STATE colorState = eOBJ_COLOR_STATE.WHITE;

    // Start is called before the first frame update
    void Start()
    {
        // 座標の取得

        squarePos = transform.position;

        s = gameObject.GetComponent<SpriteRenderer>();

        timer = GameObject.Find("TimerHolder").GetComponent<LevelTimer>();

        size = new Vector3(transform.localScale.x, transform.localScale.y, 0);
    }

    // オブジェクトの座標のゲット
    public Vector3 GetObjPos()
    {
        return squarePos;
    }
   

    // Update is called once per frame
    void Update()
    {
        changeColorTimer += Time.deltaTime;

        switch (state)
        {
            case eOBJ_STATE.SCALE_UP:

                switch(colorState)
                {
                    case eOBJ_COLOR_STATE.WHITE:

                        s.color = Color.white;

                        if(changeColorTimer > 0.1f)
                        {
                            changeColorTimer = 0f;

                            colorState = eOBJ_COLOR_STATE.RED;
                        }

                        break;
                    case eOBJ_COLOR_STATE.RED:

                        s.color = Color.red;

                        if (changeColorTimer > 0.1f)
                        {
                            changeColorTimer = 0f;

                            colorState = eOBJ_COLOR_STATE.WHITE;
                        }

                        break;
                }

                // サイズ変更
                size.x += 0.01f;
                size.y += 0.01f;

                this.transform.localScale = new Vector3(size.x, size.y, 0);

                if(!timer.waitingForBomb())
                {
                    state = eOBJ_STATE.BOMB;
                }

                break;
            case eOBJ_STATE.BOMB:

                
                
                s.enabled = false;
                break;
        }
       
    }
}
